<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( !defined('ID2') or !file_exists( DANE . '/' . ID2 )
	or ID2 == '/' or ID2 == '.' or strpos(ID2,'../') !== false )
	przekierowanie( '?id=edytorPlikow&b=' );

// usuwanie pliku lub folderu

if ( isset($_GET['usun']) and !odczytKonf('wysokieZabezpieczenie') ) {

	if ( is_dir( DANE . '/' . ID2 ) ) {
		if ( count( plikiFolderu( DANE . '/' . ID2 ) ) == 0 ) {
			rmdir( DANE . '/' . ID2 );
			przekierowanie( '?id=edytorPlikow&b=' . ((dirname(ID2)=='.') ? '' : dirname(ID2)) . '&usunietoFolder=' . basename(ID2) );
		}
		else
			komunikat( 'zle.Folder <strong>' . basename(ID2) . '</strong> nie został usunięty, gdyż nie jest pusty.' );
	}

	else {
		unlink( DANE . '/' . ID2 );
		przekierowanie( '?id=edytorPlikow&b=' . ((dirname(ID2)=='.') ? '' : dirname(ID2)) . '&usunietoPlik=' . basename(ID2) );
	}

}

if ( $_SERVER['REQUEST_METHOD'] == 'POST' and !odczytKonf('wysokieZabezpieczenie') ) {

	// tworzenie pliku lub tworzenie folderu, lub przeniesienie pliku z wysłanych

	if ( isset($_GET['utworz']) ) {

		$przekierowaniePo = null;

		if ( !empty($_POST['pustyPlik']) ) {

			if ( !sprawdzNazwe( $_POST['pustyPlik'] ) )
				komunikat( 'zle.Nazwa <strong>' . $_POST['pustyPlik'] . '</strong> jest niewłaściwa.' );
			elseif ( file_exists( DANE . '/' . ID2 . '/' . $_POST['pustyPlik']  ) )
				komunikat( 'zle.Plik o nazwie <strong>' . $_POST['pustyPlik'] . '</strong> już istnieje.' );

			else {
				file_put_contents( DANE . '/' . ID2 . '/' . $_POST['pustyPlik'], '' );
				$przekierowaniePo = '&utworzonoPlik=' . $_POST['pustyPlik'];
			}

		}

		if ( !empty($_POST['nowyFolder']) ) {

			if ( !sprawdzNazwe( $_POST['nowyFolder'] ) )
				komunikat( 'zle.Nazwa <strong>' . $_POST['nowyFolder'] . '</strong> jest niewłaściwa.' );
			elseif ( file_exists( DANE . '/' . ID2 . '/' . $_POST['nowyFolder']  ) )
				komunikat( 'zle.Folder o nazwie <strong>' . $_POST['nowyFolder'] . '</strong> już istnieje.' );

			else {
				mkdir( DANE . '/' . ID2 . '/' . $_POST['nowyFolder'] );
				$przekierowaniePo = '&utworzonoFolder=' . $_POST['nowyFolder'];
			}

		}

		if ( !empty($_POST['wyslanyPlik']) and $_POST['wyslanyPlik'] != '.' ) {

			if ( file_exists( DANE . '/' . ID2 . '/' . $_POST['wyslanyPlik']  ) )
				komunikat( 'zle.Plik o nazwie <strong>' . $_POST['wyslanyPlik'] . '</strong> już istnieje.' );

			else {
				copy(
					odczytKonf('adresPlikow') . '/' . $_POST['wyslanyPlik'],
					DANE . '/' . ID2 . '/' . $_POST['wyslanyPlik']
				);
				$przekierowaniePo = '&utworzonoPlik=' . $_POST['wyslanyPlik'];
			}

		}

		if ( komunikat() == null and !empty($przekierowaniePo)  )
			przekierowanie( '?id=edytorPlikow&b=' . ID2 . $przekierowaniePo );

	}

	// przenoszenie folderu

	elseif ( isset($_GET['przenies']) and !empty($_POST['lokalizacja']) ) {

		// sprawdzanie nazwy każdego z elementów adresu
		$_POST['lokalizacja'] = explode( '/', $_POST['lokalizacja'] );
		foreach ( $_POST['lokalizacja'] as $klucz => $element ) {
			if ( !empty($element) ) {
				$_POST['lokalizacja'][$klucz] = prostaNazwa( $element, false );
				if ( !sprawdzNazwe($element) )
					$niewlasciwaNazwa = true;
			}
		}
		$_POST['lokalizacja'] = implode( '/', $_POST['lokalizacja'] );

		if ( isset($niewlasciwaNazwa) )
			komunikat( 'zle.Nazwa któregoś z folderów jest niewłaściwa.' );

		elseif ( !file_exists( DANE . '/' . dirname($_POST['lokalizacja']) ) ) {
			komunikat( 'zle.Ścieżka nie istnieje.' );
		}

		elseif ( file_exists( DANE . '/' . $_POST['lokalizacja']  ) )
			komunikat( 'zle.Folder o nazwie <strong>' . basename($_POST['lokalizacja']) . '</strong> już istnieje.' );

		else {

			rename( DANE . '/' . ID2, DANE . '/' . $_POST['lokalizacja'] );
			przekierowanie( '?id=edytorPlikow&b=' . $_POST['lokalizacja'] . '&przeniesionoFolder=' . basename($_POST['lokalizacja']) );

		}

	}

	// zapis pliku

	elseif ( isset($_POST['zawartosc']) and isset($_POST['nazwa'])  ) {

		file_put_contents( DANE . '/' . ID2, $_POST['zawartosc'], LOCK_EX );
		komunikat( 'dob.Plik <strong>' . basename(ID2)  . '</strong> został zapisany.' );

		// zmiana nazwy pliku
		if ( $_POST['nazwa'] != basename(ID2) ) {

			if ( file_exists( DANE . '/' . dirname(ID2) . '/' . $_POST['nazwa']  ) )
				komunikat( 'zle.Plik o nazwie <strong>' . $_POST['nazwa'] . '</strong> już istnieje.' );

			elseif ( !sprawdzNazwe( $_POST['nazwa'] ) )
				komunikat( 'zle.Nazwa <strong>' . $_POST['nazwa'] . '</strong> jest niewłaściwa.' );

			else {
				rename(
					DANE . '/' . ID2,
					DANE . '/' . dirname(ID2) . '/' . $_POST['nazwa']
				);
				przekierowanie( '?id=edytorPlikow&b=' . ((dirname(ID2)=='.') ? '' : dirname(ID2)) . '&zmienionoNazwe=' . $_POST['nazwa'] );
			}

		}

	}

}

if ( isset($_GET['utworzonoPlik']) )
	komunikat( 'dob.Plik <strong>' . $_GET['utworzonoPlik'] . '</strong> został utworzony.' );
if ( isset($_GET['utworzonoFolder']) )
	komunikat( 'dob.Folder <strong>' . $_GET['utworzonoFolder'] . '</strong> został utworzony.' );

if ( isset($_GET['usunietoPlik']) )
	komunikat( 'dob.Plik <strong>' . $_GET['usunietoPlik'] . '</strong> został usunięty.' );
if ( isset($_GET['usunietoFolder']) )
	komunikat( 'dob.Folder <strong>' . $_GET['usunietoFolder'] . '</strong> został usunięty.' );

if ( isset($_GET['zmienionoNazwe']) )
	komunikat( 'dob.Plik <strong>' . $_GET['zmienionoNazwe'] . '</strong> został zapisany pod nową nazwą.' );
if ( isset($_GET['przeniesionoFolder']) )
	komunikat( 'dob.Folder <strong>' . $_GET['przeniesionoFolder'] . '</strong> został przeniesiony.' );

include (SYSTEM.'/admin/naglowek.php');
?>
<h2><b><?php
echo '<a title="Przejdź go najwyszego folderu." href="?id=edytorPlikow">', odczytKonf('edytorPlikowGlownyFolder'), '</a>';
$lokalizacja = explode( '/', ID2 );

// nawigacja z odnośnikami do pojedycznych elementów

foreach ( $lokalizacja as $nazwaTegoElementu ) {

	if( empty($nazwaTegoElementu) )
		continue;

	echo '/<a title="Przejdź do &bdquo;', $nazwaTegoElementu, '&rdquo;." href="?id=edytorPlikow&b=';

	foreach ( $lokalizacja as $lokalizacjaCzastkowa ) {
		if( empty($lokalizacjaCzastkowa) )
			continue;
		echo $lokalizacjaCzastkowa;
		if ( $lokalizacjaCzastkowa == $nazwaTegoElementu )
			break;
		else
			echo '/';
	}

	echo '">', $nazwaTegoElementu, '</a>';

}
?></b> &mdash; edytor</h2>

<?php
if ( odczytKonf('wysokieZabezpieczenie') ) {
?>

<p class="uwaga">Tryb wysokiego zabezpieczenia jest obecnie włączony, dlatego dostęp do tego narzędzia jest niemożliwy. Aby zmienić ten stan, wyłącz tryb wysokiego zabezpieczenia, edytując plik konfiguracyjny.</p>

<?php
}

// tworzenie pliku lub folderu

elseif ( isset($_GET['utworz']) ) {
	$listaPlikow = listaPlikow();
	$listaPlikow['.'] = '(żaden)';
?>

<form method="post">

<table>
	<tr> <td>Utwórz tutaj pusty plik:</td> <td><input type="text" name="pustyPlik" /></td> </tr>
	<tr> <td>Utwórz tutaj nowy folder:</td> <td><input type="text" name="nowyFolder" /></td> </tr>
	<tr> <td>Skopiuj tutaj wysłany plik:</td> <td><select name="wyslanyPlik"><?php generujListeWyboru( $listaPlikow, '.' ) ?></select></td> </tr>
</table>

<p class="przyciskWysylania"><input type="submit" value="Utwórz plik lub folder" /></p>

</form>

<?php
}

// przenoszenie folderu

elseif ( isset($_GET['przenies']) and is_dir( DANE . '/' . ID2 ) ) {
?>

<form method="post">

<table>
	<tr> <td>Dotychczasowa lokalizacja:</td> <td><?php echo ID2 ?></td> </tr>
	<tr> <td>Nowa lokalizacja:</td> <td><input type="text" name="lokalizacja" value="<?php echo ID2 ?>" required /></td> </tr>
</table>

<p class="przyciskWysylania"><input type="submit" value="Przenieś folder" /></p>

</form>

<?php
}

// wyświetlanie zawartości folderu

elseif ( is_dir( DANE . '/' . ID2 ) ) {

	$plikiWFolderze = plikiFolderu( DANE . '/' . ID2, false, false );
?>

<ul class="listaKafelkowa">
<?php
	if ( !empty($plikiWFolderze) ) {

		$plikiWFolderze = array_map( 'basename', $plikiWFolderze );

		$typyPlikow = array( 'php' => 'Skrypt PHP', 'js' => 'Skrypt JavaScript', 'css' => 'Styl CSS', 'html' => 'Dokument HTML', 'htm' => 'Dokument HTML', 'wtk' => 'Plik konfiguracji WT', 'wtu' => 'Plik ustawień WT', 'wtz' => 'Plik zawartości WT', 'txt' => 'Dokument tekstowy', 'log' => 'Plik dziennika' );

		$ukrytePliki = array( 'strony', 'szkice', 'pliki', 'wtk', 'index.html' );
		// W tym miejscu celowo nie użyłem odczytKonf('adresPlików'), lecz wpisałem bezpośrednio 'pliki'.
		// Uważam, że osoba, która zmieni w WTK adres foldera plików, będzie na tyle świadoma, że nie usunie go przypadkiem. ;-)

		foreach ( $plikiWFolderze as $nazwaPliku ) {

			// gdy ograniczenia są włączone, pomijamy ważne pliki systemu WizyTówka
			if ( odczytKonf('edytorPlikowOgraniczenia') and ID2 == '' and in_array($nazwaPliku, $ukrytePliki) )
				continue;

			$folder = false;
			$edycja = true;

			if ( is_dir( DANE . '/' . ID2 . '/' . $nazwaPliku ) ) {
				$typPliku = 'Folder';
				$folder   = true;
			}

			else {

				$rozszerzenie = substr( $nazwaPliku, strrpos($nazwaPliku,'.')+1 );
				$typPliku = ( isset($typyPlikow[$rozszerzenie]) ) ? $typyPlikow[$rozszerzenie] :'Nieznany plik';

				if ( odczytKonf('edytorPlikowOgraniczenia') and !isset($typyPlikow[$rozszerzenie]) )
					$edycja = false;
					// gdy ograniczenia są włączone, ukrywamy odnośnik do edycji pliku w nieznanym formacie

			}
?>
	<li>
		<span><a href="<?php if ($edycja) echo '?id=edytorPlikow&b=', ((ID2=='') ? '' : ID2.'/'), $nazwaPliku; else echo DANE, '/', ID2, '/', $nazwaPliku ?>"><?php echo $nazwaPliku ?></a></span>
		<span class="opis"><?php echo $typPliku ?></span> |
		<?php if ($edycja) { ?>
		<a href="?id=edytorPlikow&b=<?php echo ((ID2=='') ? '' : ID2.'/'), $nazwaPliku ?>"><?php echo ($folder) ? 'Otwórz' : 'Edytuj' ?></a> |
		<?php } else { ?>
		<a href="<?php echo DANE, '/', ID2, '/', $nazwaPliku ?>">Otwórz</a> |
		<?php } ?>
		<?php if ($folder) { ?>
		<a href="?id=edytorPlikow&b=<?php echo ((ID2=='') ? '' : ID2.'/'), $nazwaPliku ?>&przenies">Przenieś</a> |
		<?php } ?>
		<a href="?id=edytorPlikow&b=<?php echo ((ID2=='') ? '' : ID2.'/'), $nazwaPliku ?>&usun" onclick="return confirm('Czy na pewno chcesz usunąć ten <?php echo ($folder) ? 'folder' : 'plik' ?>?')">Usuń</a>
	</li>
<?php
		}
	}
?>
	<li class="dodaj">
		<span><a href="?id=edytorPlikow&b=<?php echo ID2 ?>&utworz">Utwórz plik lub folder</a></span>
	</li>
</ul>

<?php
}

// odczyt i zapis pliku

else  {
	$nazwaPliku   = basename(ID2);
	$rozszerzenie = substr( $nazwaPliku, strrpos($nazwaPliku,'.')+1 );
	$typyMIME     = array( 'php' => 'application/x-httpd-php', 'css' => 'text/css', 'js' => 'text/javascript', 'wtu' => 'text/x-ini', 'xml' => 'application/xml', 'html' => 'text/html', 'htm' => 'text/html' );
?>

<form method="post">

<style scoped>
	@import url(http://fonts.googleapis.com/css?family=Source+Code+Pro:400,700&subset=latin-ext);
	<?php if ( odczytKonf('edytorPlikowPodswietlanieSkladni') ) { ?>
	@import url(<?php echo SYSTEM ?>/admin/pliki/codemirror/codemirror.css);
	@import url(<?php echo SYSTEM ?>/admin/pliki/codemirror/<?php echo odczytKonf('kontrastowyPanelAdmin') ? 'ambiance' : 'neo' ?>.css);
	<?php } ?>
</style>

<table>
	<tr> <td><textarea name="zawartosc" class="poleEdytora" id="poleEdytoraPlikow" spellcheck="false"><?php echo htmlspecialchars( file_get_contents( DANE . '/' . ID2 ) ) ?></textarea></td> </tr>
	<tr> <td><input name="nazwa" value="<?php echo $nazwaPliku ?>" class="poleEdytoraNazwa" /></td> </tr>
</table>

<?php if ( odczytKonf('edytorPlikowPodswietlanieSkladni') ) {  // CodeMirror do podświetlania składni  ?>
<script src="<?php echo SYSTEM ?>/admin/pliki/codemirror/codemirror.js"></script>

<script>
	var editor = CodeMirror.fromTextArea(document.getElementById("poleEdytoraPlikow"), {
        mode: "<?php echo isset($typyMIME[$rozszerzenie]) ? $typyMIME[$rozszerzenie] : 'text/plain' ?>",
		theme: "<?php echo odczytKonf('kontrastowyPanelAdmin') ? 'ambiance' : 'neo' ?>",
		lineNumbers: true,
		lineWrapping: true,
		tabSize: 4,
		indentUnit: 4,
		indentWithTabs: true,
		matchBrackets: true,
        autoCloseBrackets: true,
		matchTags: {bothTags: true},
        autoCloseTags: true,
	});
</script>
<?php } ?>

<?php if ( $rozszerzenie == 'wtk' or $rozszerzenie == 'wtz' ) { ?>
<p class="uwaga">Uwaga! Nieprawidłowa modyfikacja tego pliku niekoniecznie spowoduje eksplozję twojego komputera, jednak może uniemożliwić prawidłowe funkcjonowanie WizyTówki. Edytuj go ostrożnie.</p>
<?php } ?>

<p class="przyciskWysylania"><input type="submit" value="Zapisz plik" /></p>

</form>

<?php
}
?>

<?php
include (SYSTEM.'/admin/stopka.php');