<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( $_SERVER['REQUEST_METHOD'] == 'POST' and !odczytKonf('wysokieZabezpieczenie') ) {

	$_POST[ $_POST['nowe']['nazwa'] ] = $_POST['nowe']['wartosc'];
	unset( $_POST['nowe'] );

	foreach ( $_POST as $ustawienie => $wlasciwosc ) {
		if ( $wlasciwosc != 'WTK_USUN' and !empty($ustawienie) )
			$konfiguracjaZmodyfikowana[$ustawienie] = $wlasciwosc;
	}

	zapisKonf( bezpiecznyHTML($konfiguracjaZmodyfikowana), true );

	komunikat(1);

}

include (SYSTEM.'/admin/naglowek.php');
?>
<style scoped>
	tr:target a { font-weight: bold; }
	tr a { color: inherit; }
</style>

<h2>Wyjątkowo Trudna Konfiguracja</h2>

<?php if ( odczytKonf('wysokieZabezpieczenie') ) { ?>

<p class="uwaga">Tryb wysokiego zabezpieczenia jest obecnie włączony, dlatego dostęp do tego narzędzia jest niemożliwy. Aby zmienić ten stan, wyłącz tryb wysokiego zabezpieczenia, edytując plik konfiguracyjny.</p>

<?php } else { ?>

<p class="uwaga">Uwaga! Nieprawidłowa modyfikacja konfiguracji niekoniecznie spowoduje eksplozję twojego komputera, jednak może uniemożliwić prawidłowe funkcjonowanie WizyTówki. Edytuj ją ostrożnie.</p>

<form method="post">

<table>
<?php
	$konfiguracja = odczytKonf();
	ksort( $konfiguracja );
	foreach ( $konfiguracja as $ustawienie => $wartosc ) {
?>
	<tr id="<?php echo $ustawienie ?>"> <td><a tabindex="-999" href="#<?php echo $ustawienie ?>"><?php echo $ustawienie ?></a></td> <td><input type="text" name="<?php echo $ustawienie ?>" value="<?php echo usunZnakNowejLinii($wartosc) ?>" /></td> </tr>
<?php
	}
?>
	<tr> <td><input type="text" name="nowe[nazwa]" placeholder="(nowe ustawienie)" /></td> <td><input type="text" name="nowe[wartosc]" placeholder="(wartość)" /></td> </tr>
</table>

<p class="przyciskWysylania"><input type="submit" value="Zapisz plik konfiguracyjny" /></p>

</form>

<?php } ?>
<?php
include (SYSTEM.'/admin/stopka.php');