<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( empty($wtZawartoscStrony) ) {
?>
<p class="wtKomunikat">Do tego magazynu plików nie dodano jeszcze żadnego pliku.</p>
<?php
}

else {

	// jeżeli w ID2 jest jakaś nazwa pliku z tablicy zawartości, a plik istnieje, na etapie nagłówków HTTP następuje exit();, jeżeli doszliśmy do tego momentu skryptu - oznacza to, że plik jest w magazynie, ale fizycznie już nie istnieje
	if ( defined('ID2') and isset($wtZawartoscStrony[ID2]) ) {
?>
<p class="wtKomunikat">Plik &bdquo;<?php echo $wtZawartoscStrony[ID2]['nazwaPliku'] ?>&rdquo; nie istnieje.</p>
<?php
	}

	$wtZawartoscStrony = sortowanie( $wtZawartoscStrony, $wtUstawieniaStrony['sortowanie'], $wtUstawieniaStrony['sortowanieOdwrotnie'] );
?>
<table class="wtMagazynPlikow">
<?php
	if ( $wtUstawieniaStrony['naglowkiKolumn'] ) {

		echo '<tr class="wtMagazynPlikow_nazwaPliku"> <th>Nazwa pliku</th> ';

		if ( $wtUstawieniaStrony['kolumny']['opis'] )
			echo '<th class="wtMagazynPlikow_opis">Opis</th> ';

		if ( $wtUstawieniaStrony['kolumny']['rozmiar'] )
			echo '<th class="wtMagazynPlikow_rozmiar">Rozmiar</th> ';

		if ( $wtUstawieniaStrony['kolumny']['dataDodania'] )
			echo '<th class="wtMagazynPlikow_dataDodania">Data dodania</th> ';

		echo '</tr>', "\n";

	}

	foreach ( $wtZawartoscStrony as $klucz => $element ) {

		echo '<tr> <td class="wtMagazynPlikow_nazwaPliku"><a href="', wtOdnosnik( '', $klucz ), '">', tekst($element['nazwaWyswietlana']), '</a></td> ';

		if ( $wtUstawieniaStrony['kolumny']['opis'] )
			echo '<td class="wtMagazynPlikow_opis">', ograniczonyHTML( tekst( $element['opis'] ) ), '</td> ';

		if ( $wtUstawieniaStrony['kolumny']['rozmiar'] )
			echo '<td class="wtMagazynPlikow_rozmiar">', (( file_exists( odczytKonf('adresPlikow') . '/' . $element['nazwaPliku'] ) ) ? rozmiarPliku($element['nazwaPliku']) : '&mdash;'), '</td> ';

		if ( $wtUstawieniaStrony['kolumny']['dataDodania'] )
			echo '<td class="wtMagazynPlikow_dataDodania">', pokazDate( $element['dataDodania'] ), '</td> ';

		echo '</tr>', "\n";

	}
?>
</table>
<?php

}