<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {

	if ( isset($_POST['naglowekLogo']) and $_POST['naglowekLogo'] == '.' )
		$_POST['naglowekLogo'] = '';

	if ( $_POST['naglowekFavikona'] == '.' )
		$_POST['naglowekFavikona'] = '';

	// zamiana elementów stopki na formę zdolną do zapisu w konfiguracji
	$_POST['stopkaDodatkowo'] = str_replace( "\n", '\n', str_replace('\n',null,$_POST['stopkaDodatkowo']) );

    zapisKonfPOST();

	komunikat(1);

}

$listaPlikowGraficznych = listaPlikow('bmp;jpg;jpeg;svg;png;gif');
$listaPlikowIkon        = listaPlikow('ico;png');

$listaPlikowGraficznych['.'] = '(brak logo)';
$listaPlikowIkon['.']        = '(brak favikony)';

$odczytMotywu   = odczytTypuMotywu( 'motywy', odczytKonf('motyw') );

$odczytLogo     = ( odczytKonf('naglowekLogo')     ) ? odczytKonf('naglowekLogo') : '.';
$odczytFavikona = ( odczytKonf('naglowekFavikona') ) ? odczytKonf('naglowekFavikona') : '.';

$listaOstatniejAktualizacji = array( 'witryna' => 'Cała witryna', 'strona' => 'Pojedyncza strona' );

include (SYSTEM.'/admin/naglowek.php');
?>
<h2>Nagłówek i stopka</h2>

<form method="post">

<h3>Nagłówek witryny</h3>

<table>
	<tr> <td>Niestandardowy tytuł witryny:</td> <td><input type="text" name="naglowekNiestandardowy" value="<?php echo odczytKonf('naglowekNiestandardowy') ?>" /></td> </tr>
	<tr> <td>Hasło opisujące witrynę:</td> <td><input type="text" name="naglowekHaslo" value="<?php echo odczytKonf('naglowekHaslo') ?>" <?php wylaczElement( $odczytMotywu['mozliwosci']['haslo'], false ) ?> /></td> </tr>
	<tr> <td>Własne logo:</td> <td><select name="naglowekLogo" <?php wylaczElement( $odczytMotywu['mozliwosci']['logo'], false ) ?>><?php generujListeWyboru( $listaPlikowGraficznych, $odczytLogo ) ?></select></td> </tr>
	<tr> <td>Własna favikona:</td> <td><select name="naglowekFavikona"><?php generujListeWyboru( $listaPlikowIkon, $odczytFavikona ) ?></select></td> </tr>
</table>

<?php
if( !$odczytMotywu['mozliwosci']['logo'] or !$odczytMotywu['mozliwosci']['haslo'] ) {
?>
<p class="uwaga">Używany obecnie motyw &bdquo;<?php echo $odczytMotywu['informacje']['nazwa'] ?>&rdquo; nie obsługuje możliwości <?php echo (!$odczytMotywu['mozliwosci']['logo']) ? 'wstawienia własnego logo' : 'ustawienia hasła witryny' ?>.</p>
<?php
}
?>

<h3>Stopka witryny</h3>

<table>
	<tr> <td>Dodatkowa treść stopki:</td> <td><textarea name="stopkaDodatkowo"><?php echo str_replace('\n',"\n",odczytKonf('stopkaDodatkowo')) ?></textarea></td> </tr>
	<?php if ( strpos(odczytKonf('stopkaDodatkowo'),'%aktualizacja%') !== false ) { ?>
	<tr> <td>Ostatnia aktualizacja:</td> <td><select name="stopkaOstatniaAktualizacja"><?php generujListeWyboru( $listaOstatniejAktualizacji, odczytKonf('stopkaOstatniaAktualizacja') ) ?></select></td> </tr>
	<?php } ?>
	<tr>
		<td><input type="checkbox" name="stopkaAutor" value="1" <?php zaznaczCheckbox( odczytKonf('stopkaAutor') ) ?> id="op11" /><label for="op11">Znak copyright, autor witryny, rok</label></td>
		<td><input type="checkbox" name="stopkaPanelAdmin" value="1" <?php zaznaczCheckbox( odczytKonf('stopkaPanelAdmin') ) ?> id="op12" /><label for="op12">Odnośnik do panelu administracyjnego</label></td>
	</tr>
</table>

<p class="informacja">Każdy element stopki umieść w osobnym wierszu. Zmienna <kbd>%aktualizacja%</kbd> pozwala na umieszczenie daty ostatniej aktualizacji witryny lub strony. <?php if ( odczytKonf('statystyki') ) { ?>Zmienna <kbd>%licznik%</kbd> zawiera liczbę odwiedzających według wbudowanych uproszczonych statystyk odwiedzin.<?php } ?> W dodatkowej treści stopki można korzystać ze znaczników HTML.</p>

<input type="hidden" name="checkboksy" value="stopkaAutor,stopkaPanelAdmin" />
<p class="przyciskWysylania"><input type="submit" value="Zapisz ustawienia" /></p>

</form>
<?php
include (SYSTEM.'/admin/stopka.php');