<?php
// WizyTówka 4
if (!defined('WT')) exit();


// integracja z CKEditorem
if ( isset($_GET['CKEditor']) and isset($_GET['CKEditorFuncNum']) )
	$integracjaZCKEditorem = true;

if ( isset($_GET['usunPlik']) ) {

	if ( file_exists( odczytKonf('adresPlikow') . '/' . $_GET['usunPlik'] ) ) {

		// usunięcie pliku i ew. miniatury
		unlink( odczytKonf('adresPlikow') . '/' . $_GET['usunPlik'] );

		if ( file_exists( odczytKonf('adresPlikow') . '/miniatury/' . $_GET['usunPlik'] . '_min' ) )
			unlink( odczytKonf('adresPlikow') . '/miniatury/' . $_GET['usunPlik'] . '_min' );

		komunikat( 'dob.Plik <strong>' . $_GET['usunPlik'] . '</strong> został usunięty.' );

	}

}

if ( isset($_GET['zmienionoNazwePliku']) )
	komunikat( 'dob.Plik <strong>' . $_GET['zmienionoNazwePliku'] . '</strong> został zapisany pod nową nazwą.' );

if ( isset($_GET['wyslanoPliki']) )
	komunikat( 'dob.Pliki zostały wysłane.' );

include (SYSTEM.'/admin/naglowek.php');
?>

<?php
// integracja z CKEditorem
if ( isset($integracjaZCKEditorem) ) {
?>
<script>
	var body = document.getElementsByTagName('body')
	body[0].style.overflow = 'hidden';

	function wstawDoCKE ( nazwaPliku ) {
		window.opener.CKEDITOR.tools.callFunction(
			<?php echo $_GET['CKEditorFuncNum'] ?>,
			'<?php echo odczytKonf('adres'), '/', odczytKonf('adresPlikow') ?>/' + nazwaPliku,
			''
		);
		window.close();
	}
</script>

<div class="zintegrowanaListaPlikow">

<style scoped>
	div.zintegrowanaListaPlikow { background: inherit; position: fixed; left: 0; right: 0; bottom: 0; top: 0; overflow-y: auto; padding: 0.5em 2em; }
	ul.listaKafelkowa { margin-bottom: 2em; }
	li.dodaj { display: none !important; }
	img.podglad { max-width: 215px; height: 150px; margin-top: 0.25em; }
	div.komunikatPustki { margin: 8em 0; text-align: center; }
</style>
<?php
}
?>

<h2>Wysłane pliki</h2>

<ul class="listaKafelkowa">
<?php
$listaPlikow = (isset($integracjaZCKEditorem) and isset($_GET['tylkoGraficzne'])) ? listaPlikow('bmp;jpg;jpeg;svg;png;gif') : listaPlikow();
if ( $listaPlikow != false ) {
?>
<?php
	foreach ( $listaPlikow as $nazwaPliku ) {
?>
	<li>
<?php
		if ( isset($integracjaZCKEditorem) ) {

			if ( isset($_GET['tylkoGraficzne']) ) {
				$miniaturaIstnieje = file_exists( odczytKonf('adresPlikow') . '/miniatury/' . $nazwaPliku . '_min' ) ? true : false;
				$adresPodgladu = ($miniaturaIstnieje) ? odczytKonf('adresPlikow') . '/miniatury/' . $nazwaPliku . '_min' : odczytKonf('adresPlikow') . '/' . $nazwaPliku;
?>
		<span><img src="<?php echo $adresPodgladu ?>" class="podglad" title="<?php echo $nazwaPliku ?>" alt="<?php echo $nazwaPliku ?>" /></span>
		<?php if ($miniaturaIstnieje) { ?><a href="#" onclick="wstawDoCKE('<?php echo 'miniatury/',$nazwaPliku,'_min' ?>')">Wstaw miniaturkę</a> |<?php } ?>
		<a href="#" onclick="wstawDoCKE('<?php echo $nazwaPliku ?>')">Wstaw obraz</a>
<?php
			}
			else {
?>
		<span><a href="<?php echo odczytKonf('adresPlikow'), '/', $nazwaPliku ?>" title="<?php echo $nazwaPliku ?>"><?php echo $nazwaPliku ?></a></span>
		<span class="opis"><?php echo rozmiarPliku($nazwaPliku) ?></span> |
		<a href="#" onclick="wstawDoCKE('<?php echo $nazwaPliku ?>')">Wstaw do zawartości</a>
<?php
			}

		}
		else {
?>
		<span><a title="<?php echo $nazwaPliku ?>" href="?id=edycjaPliku&b=<?php echo $nazwaPliku ?>"><?php echo $nazwaPliku ?></a></span>
		<span class="opis"><?php echo rozmiarPliku($nazwaPliku) ?></span> |
		<a href="<?php echo odczytKonf('adresPlikow'), '/', $nazwaPliku ?>">Otwórz</a> |
		<a href="?id=edycjaPliku&b=<?php echo $nazwaPliku ?>">Edytuj</a> |
		<a href="?id=wyslanePliki&usunPlik=<?php echo $nazwaPliku ?>" onclick="return confirm('Czy na pewno chcesz usunąć ten plik?')">Usuń</a>
<?php
		}
?>
	</li>
<?php
	}
}
?>
	<li class="dodaj">
		<span><a href="?id=wyslijPliki">Wyślij pliki</a></span>
	</li>
</ul>

<?php
if ( isset($integracjaZCKEditorem) ) {
?>

	<?php if ( !$listaPlikow ) { ?><div class="komunikatPustki"><p>Nie przesłano jeszcze żadnego pliku<?php echo (isset($_GET['tylkoGraficzne'])) ? ' graficznego' : '' ?>.</p><p>Zamknij to okienko i kliknij kartę <strong>Wyślij</strong>, aby przesłać <?php echo (isset($_GET['tylkoGraficzne'])) ? 'pierwszą fotografię lub obraz' : 'pierwszy plik' ?>.</p></div><?php } ?>

</div>

<?php
}
?>

<?php
include (SYSTEM.'/admin/stopka.php');