<?php
// WizyTówka 4
if (!defined('WT')) exit();


// integracja z CKEditorem
if ( isset($_GET['CKEditor']) and isset($_GET['CKEditorFuncNum']) )
	$integracjaZCKEditorem = true;

if ( $_SERVER['REQUEST_METHOD'] == 'POST' or isset($integracjaZCKEditorem) ) {

	// integracja z CKEditorem
	if ( isset($integracjaZCKEditorem) and isset($_FILES['upload']) ) {
		$_FILES['plik']['name'][0]     = $_FILES['upload']['name'];
		$_FILES['plik']['tmp_name'][0] = $_FILES['upload']['tmp_name'];
		$_FILES['plik']['size'][0]     = $_FILES['upload']['size'];
		$_FILES['plik']['error'][0]    = $_FILES['upload']['error'];
	}

	if ( !empty($_FILES['plik']['name'][0]) ) {

		foreach ( $_FILES['plik']['name'] as $klucz => $nazwaPliku ) {

			// integracja z CKEditorem
			if ( $_FILES['plik']['size'][$klucz] > odczytKonf('wysylaniePlikowMaksymalnieBajtow') ) {
				$maksymalnyRozmiarPliku = round( odczytKonf('wysylaniePlikowMaksymalnieBajtow') / 1024 / 1024, 2);
				komunikat( 'zle.Plik <strong>' . $nazwaPliku . '</strong> jest zbyt duży. Maksymalny rozmiar pliku: ' . $maksymalnyRozmiarPliku . ' MiB.' );
				continue;
			}

			$nazwaPliku = prostaNazwa( $nazwaPliku, odczytKonf('wysylaniePlikowZawszeMaleLitery') );

			if ( !sprawdzNazwe( $nazwaPliku ) ) {
				komunikat( 'zle.Nazwa pliku <strong>' . $nazwaPliku . '</strong> jest niewłaściwa. Plik nie został przesłany.' );
				continue;
			}

			if ( file_exists( odczytKonf('adresPlikow') . '/' . $nazwaPliku ) ) {
				komunikat( 'zle.Plik o nazwie <strong>' . $nazwaPliku . '</strong> już istnieje. Plik nie został przesłany.' );
				continue;
			}

			if ( $_FILES['plik']['error'][$klucz] == 1 ) {
				komunikat( 'zle.Plik <strong>' . $nazwaPliku . '</strong> jest zbyt duży. Przekracza maksymalny rozmiar określony przez PHP.' );
				continue;
			}

			if ( $_FILES['plik']['error'][$klucz] != 0 ) {
				komunikat( 'zle.Wystąpił błąd PHP nr ' . $_FILES['plik']['error'][$klucz] . ' przy wysyłaniu pliku <strong>' . $nazwaPliku . '</strong>.  Plik nie został przesłany.' );
				continue;
			}

			if ( !is_uploaded_file( $_FILES['plik']['tmp_name'][$klucz] ) or
				!move_uploaded_file ( $_FILES['plik']['tmp_name'][$klucz], odczytKonf('adresPlikow') . '/' . $nazwaPliku ) ) {
				komunikat( 'zle.Wystąpił błąd przy wysyłaniu pliku <strong>' . $nazwaPliku . '</strong>.  Plik nie został przesłany.' );
				continue;
			}

			// generowanie minaturek
			if ( extension_loaded('gd') ) {

				$rozszerzenieTegoPliku = strtolower( substr( $nazwaPliku, strrpos($nazwaPliku,'.')+1 ) );
				$rozszerzaniaMiniatur  = array( 'jpg', 'jpeg', 'png', 'gif' );
				$informacjeObrazu      = getimagesize( odczytKonf('adresPlikow') . '/' . $nazwaPliku );

				if ( $informacjeObrazu !== false and in_array( $rozszerzenieTegoPliku, $rozszerzaniaMiniatur ) ) {

					$maksRozmiar = 200;
					$szerokosc = ( $informacjeObrazu[0] >= $informacjeObrazu[1] ) ? odczytKonf('rozmiarMiniatur') : $informacjeObrazu[0] * odczytKonf('rozmiarMiniatur') / $informacjeObrazu[1];
					$wysokosc  = ( $informacjeObrazu[0] <= $informacjeObrazu[1] ) ? odczytKonf('rozmiarMiniatur') : $informacjeObrazu[1] * odczytKonf('rozmiarMiniatur') / $informacjeObrazu[0];

					switch( $informacjeObrazu[2] ) {
						case IMAGETYPE_JPEG:
							$plotnoObrazu = imagecreatefromjpeg( odczytKonf('adresPlikow') . '/' . $nazwaPliku );
							break;
						case IMAGETYPE_GIF:
							$plotnoObrazu = imagecreatefromgif( odczytKonf('adresPlikow') . '/' . $nazwaPliku );
							break;
						case IMAGETYPE_PNG:
							$plotnoObrazu = imagecreatefrompng( odczytKonf('adresPlikow') . '/' . $nazwaPliku );
					}

					$plotnoMiniatury = imagecreatetruecolor( $szerokosc, $wysokosc );
					imagecopyresampled( $plotnoMiniatury, $plotnoObrazu, 0,0,0,0, $szerokosc, $wysokosc, $informacjeObrazu[0], $informacjeObrazu[1] );
					imagejpeg( $plotnoMiniatury, odczytKonf('adresPlikow') . '/miniatury/' . $nazwaPliku . '_min' );

				}

			}

			// gdy nie wyskoczymy z pętli, wszystko jest OK
			$ok = 1;

		}

	}

	else
		komunikat('zle.Nie wskazano żadnego pliku do wysłania lub łączny rozmiar plików jest zbyt duży.');

	if ( isset($ok) and !komunikat() and !isset($integracjaZCKEditorem) )
		przekierowanie( '?id=wyslanePliki&wyslanoPliki' );

}

// integracja z CKEditorem
if ( isset($integracjaZCKEditorem) ) {
?>
<!doctype html>
<script>
	window.parent.CKEDITOR.tools.callFunction(
		<?php echo $_GET['CKEditorFuncNum'] ?>,
		'<?php echo ( isset($nazwaPliku) and isset($ok) ) ? odczytKonf('adres') . '/' . odczytKonf('adresPlikow') . '/' . $nazwaPliku : '' ?>',
		'<?php echo ( komunikat() != null ) ? substr( zastepowanie( komunikat(), array('<strong>'=>'„','</strong>'=>'”') ), 4 ) : '' ?>'
	)
</script>
<?php
	exit();
}

include (SYSTEM.'/admin/naglowek.php');
?>
<h2>Wyślij pliki</h2>

<form method="post" enctype="multipart/form-data">

<table>
	<tr> <td>Wybór plików do przesłania:</td> <td><input type="file" name="plik[]" value="Wybierz pliki" multiple /></td> </tr>
</table>

<p class="informacja">W zależności od możliwości używanej przeglądarki internetowej możesz przesłać tylko jeden lub kilka plików jednocześnie. Jeśli przeglądarka to umożliwia, w celu wskazania kilku plików należy przeciągnąć zaznaczenie myszką lub wskazywać pojedyncze pliki, trzymając wciśnięty przycisk <code>Ctrl</code>. <?php if ( ini_get('max_file_uploads') != '' ) { ?>Jednocześnie można przesłać maksymalnie <?php echo ini_get('max_file_uploads') ;?> plików.<?php } ?></p>

<p class="przyciskWysylania"><input type="submit" value="Wyślij pliki" /></p>

</form>
<?php
include (SYSTEM.'/admin/stopka.php');