<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( empty($wtZawartoscStrony) ) {
?>
<p class="wtKomunikat">Do tego formularza nie dodano jeszcze żadnego pola.</p>
<?php
}

else {

	if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {

		$formularzKontaktowy = pamiecPodreczna('formularzKontaktowy');

		if ( !$formularzKontaktowy['wypelnionoChociazJednoPole'] ) {
?>
<p class="wtKomunikat">Nie wypełniono żadnego pola formularza.</p>
<?php
		}
		elseif ( $formularzKontaktowy['nieWypelnionoWymaganychPol'] ) {
?>
<p class="wtKomunikat">Nie wypełniono wszystkich wymaganych pól formularza.</p>
<?php
		}
		elseif ( $wtUstawieniaStrony['zabezpieczeniePrzedSpamem'] and !isset($_COOKIE['WT_formularz']) ) {
?>
<p class="wtKomunikat">Wymagana jest obsługa ciasteczek w przeglądarce.</p>
<?php
		}
		elseif ( $wtUstawieniaStrony['zabezpieczeniePrzedSpamem'] and time() < $_COOKIE['WT_formularz'] ) {
?>
<p class="wtKomunikat">Formularz został wypełniony zbyt szybko.</p>
<?php
		}
		elseif ( wiadomosc( $formularzKontaktowy['tresc'], $formularzKontaktowy['temat'] ) ) {
?>
<p class="wtKomunikat"><?php echo $wtUstawieniaStrony['komunikatPowodzenia'] ?></p>
<?php
		}
		else {
?>
<p class="wtKomunikat"><?php echo $wtUstawieniaStrony['komunikatNiepowodzenia'] ?></p>
<?php
		}

	}

	$wtZawartoscStrony = sortowanie( $wtZawartoscStrony, 'numerWKolejnosci' );
?>
<form method="post" class="wtFormularzKontaktowy">

<?php
	$liczbaElementow  = count($wtZawartoscStrony);
	$licznikElementow = 0;

	$rozpocznjListeOpisow = true;

	foreach ( $wtZawartoscStrony as $klucz => $element ) {

		// licznik niezbędny do umieszczenia zakończenia listy opisów
		++$licznikElementow;

		// obszar tekstowy...

		if ( $element['typElementu'] == 'obszarTekstowy' ) {

			// sztuczne domknięcie ostatniej listy opisów i wymuszenie rozpoczęcia nowej
			if ( !$rozpocznjListeOpisow )
				echo '</dl>', "\n\n";
			$rozpocznjListeOpisow = true;

			echo tekst( $element['tresc'], true ), "\n\n";

		}

		// pole formularza...

		else {

			// rozpoczęcie listy opisów
			if ( $rozpocznjListeOpisow ) {
				echo '<dl class="wtFormularzKontaktowy', ($wtUstawieniaStrony['wyswietlanie'] == 'kolumny') ? '_kolumny' : '_wiersze' ,'">', "\n";
				$rozpocznjListeOpisow = false;
			}

			echo '<dt><label for="p', $klucz, '">',  tekst($element['etykieta']), '</label>';
			if ( $element['wymagany'] )
				echo ' <span class="wtFormularzKontaktowy_gwiazdka">*</span>';
			echo '</dt>', "\n";

			echo '<dd>';

			switch ($element['typElementu']) {

				case 'input':
					echo '<input name="formularz[', $klucz, ']" type="', $element['typDanych'], '" id="p', $klucz, '" ', (($element['wymagany']) ? 'required' : ''), ' />';
					break;

				case 'select':
					echo '<select name="formularz[', $klucz, ']" id="p', $klucz, '"> ';
					foreach ( $element['opcje'] as $opcja)
						echo '<option value="', $opcja, '">', tekst($opcja), '</option> ';
					echo '</select>';
					break;

				default:
					echo '<textarea name="formularz[', $klucz, ']" id="p', $klucz, '" ', (($element['wymagany']) ? 'required' : ''), '></textarea>';

			}

			echo '</dd>', "\n";

			// zakończenie listy opisów
			if ( $licznikElementow == $liczbaElementow )
				echo '</dl>', "\n";

		}

	}

?>

<p class="wtFormularzKontaktowy_przycisk"><input type="submit" value="<?php echo $wtUstawieniaStrony['komunikatPrzycisku'] ?>" /></p>

</form>
<?php

}